#!/usr/bin/env python3

import sys

print ("{} {:13s}{} {} {} {}".format(
    "PRN", "facility:n", "A", "S", "D", "message"))
datapart = 0
subframe = 0
sync = [b'0x00' for i in range (4)]
while True:
    b = sys.stdin.buffer.read(1)
    if not b: break
    sync = sync[1:4] + [b]
    if sync != [b'\x1a', b'\xcf', b'\xfc', b'\x1d']: continue
    prn  = int.from_bytes (sys.stdin.buffer.read(  1), 'big')
    mtid = int.from_bytes (sys.stdin.buffer.read(  1), 'big')
    data =                 sys.stdin.buffer.read(212)
    rs   =                 sys.stdin.buffer.read( 32)
    vendor   = "CLAS" if (mtid >> 5) == 0b101 else ""
    facility = "Kobe" if (mtid >> 4) & 1 else "Hitachi-Ota"
    facility += ":" + str((mtid >> 3) &1)
    alert = data[0] >> 7
    if mtid & 1: # first data part
        datapart = 1
        msgnum  = ((data[0] & 0x7f) << 5) + (data[1] >> 3) # 4073
        subtype = ((data[1] & 0x07) << 1) + (data[2] >> 7)
        if subtype == 1: subframe = 1
        else:
            subframe += 1
            if subframe == 7: # reception error
                datapart = 0; subframe = 0
                continue
        print ("{} {:13s}{} {} {} Subtype {}".format(prn, facility,
            "*" if alert else " ", subframe, datapart, subtype))
    else: # continual data part
        datapart += 1
        if datapart == 6: # reception error
            datapart = 0; subframe = 0
            continue
        print ("{} {:13s}{} {} {}".format(prn, facility,
            "*" if alert else " ", subframe, datapart))
