#!/bin/bash

show(){
awk -v id=$2 -v stat="$3" -v fname=$FNAME '
BEGIN {
    lat_ref =  34.4401061;
    lon_ref = 132.4147804;
    lat2y = 4e7/360.;
    lon2x = lat2y * cos(lat_ref)
}
$6==id && 10<NR {
    n += 1;
    dlat += $3 -lat_ref; y2 +=(($3 - lat_ref) * lat2y)^2;
    dlon += $4 -lon_ref; x2 +=(($4 - lon_ref) * lon2x)^2;
    height+=$5
}
END {
    if (n!=0) {
        dx = dlon / n * lon2x;
        dy = dlat / n * lat2y;
        printf fname " " stat " %.7f %.7f %.3f %.1f%% %d %d %.2f %.2f\n",
               dlat / n + lat_ref, dlon / n + lon_ref, height / n,
               n / (NR - 10) * 100, n, NR - 10,
               sqrt (dx^2 + dy^2),
               2*sqrt(x2/n - dx^2 + y2/n - dy^2)
    }
}' $1
}

FNAME=`basename $1`
show $1 1 'fix   ' $2
show $1 2 'float ' $2
show $1 5 'single' $2
